package models

type CreateMerchantRequest struct {
	OpenId             string `json:"open_id"`              //open_id
	MerchantName       string `json:"merchant_name"`        // 店铺名称
	Industry           string `json:"industry"`             // 行业
	IndustryCategory   string `json:"industry_category"`    // 行业分类
	Contacts           string `json:"contacts"`             // 联系人
	BusinessHours      string `json:"business_hours"`       // 营业时间
	Consumption        string `json:"consumption"`          // 人均消费
	Iphone             string `json:"iphone"`               // 手机号
	Area               string `json:"area"`                 // 地区
	Address            string `json:"address"`              // 地址
	NumberPlate        string `json:"number_plate"`         // 门牌号
	BusinessLicenseUrl string `json:"business_license_url"` // 营业执照 url
	DoorHeaderUrl      string `json:"door_header_url"`      // 门头照 url
	RechargeUrl        string `json:"recharge_url"`         // 充值url
}

type GetMerchantRequest struct {
	OpenId string `json:"open_id"` //openid
}

type GetRechargeRequest struct {
	OpenId string `json:"open_id"` //openid
}

type GetRechargeReply struct {
	RechargeUrl string `json:"recharge_url"` //recharge_url
}
type MerchantListRequest struct {
	OpenId    string `json:"open_id"`
	PageSize  int    `json:"page_size"`
	PageIndex int    `json:"page_index"`
}

type UpdateMerchantRequest struct {
	ID                 int64  `json:"id"`
	MerchantName       string `json:"merchant_name"`        // 店铺名称
	Industry           string `json:"industry"`             // 行业
	IndustryCategory   string `json:"industry_category"`    // 行业分类
	Contacts           string `json:"contacts"`             // 联系人
	BusinessHours      string `json:"business_hours"`       // 营业时间
	Consumption        string `json:"consumption"`          // 人均消费
	Iphone             string `json:"iphone"`               // 手机号
	Area               string `json:"area"`                 // 地区
	Address            string `json:"address"`              // 地址
	NumberPlate        string `json:"number_plate"`         // 门牌号
	BusinessLicenseUrl string `json:"business_license_url"` // 营业执照 url
	DoorHeaderUrl      string `json:"door_header_url"`      // 门头照 url
	RechargeUrl        string `json:"recharge_url"`         // 充值url
}

type CancelCardRequest struct {
	MerchantOpenId string `json:"merchant_open_id"`
	QRMessage      string `json:"qr_message"`
}

type CancelCardV2Request struct {
	MerchantOpenId string `json:"merchant_open_id"`
	QRMessage      string `json:"qr_message"`
	Number         int    `json:"number"`
}
