package models

type CreateMerchantPayInfoRequest struct {
	MerchantOpenID  string `json:"merchant_open_id"` // 商户openid
	BusinessLicense string `json:"business_license"` // 营业执照照片
	IDCardFront     string `json:"id_card_front"`    // 身份证正面
	IDCardBack      string `json:"id_card_back"`     // 身份证反面
	IDCardHand      string `json:"id_card_hand"`     // 手持身份证
	BankAccount     string `json:"bank_account"`     // 开户行
	BankCode        string `json:"bank_code"`        // 银行卡号
	BankAddress     string `json:"bank_address"`     // 网点
	AccountName     string `json:"account_name"`     // 姓名
	MerchantType    int    `json:"merchant_type"`
	EntryInfo       string `json:"entry_info"` //入账信息

}

type GetMerchantPayInfoRequest struct {
	MerchantOpenID string `json:"merchant_open_id"` // 商户openid
}

type UpdateMerchantPayInfoRequest struct {
	ID              int    `json:"id"`
	MerchantOpenID  string `json:"merchant_open_id"` // 商户openid
	BusinessLicense string `json:"business_license"` // 营业执照照片
	IDCardFront     string `json:"id_card_front"`    // 身份证正面
	IDCardBack      string `json:"id_card_back"`     // 身份证反面
	IDCardHand      string `json:"id_card_hand"`     // 手持身份证
	BankAccount     string `json:"bank_account"`     // 开户行
	BankCode        string `json:"bank_code"`        // 银行卡号
	BankAddress     string `json:"bank_address"`     // 网点
	AccountName     string `json:"account_name"`     // 姓名
	MerchantType    int    `json:"merchant_type"`
	EntryInfo       string `json:"entry_info"` //入账信息
}
