package models

import "github.com/shopspring/decimal"

type UnifiedOrderRequest struct {
	RequestId      string          `json:"request_id"`       //request id
	OutTradeNo     string          `json:"out_trade_no"`     //交易id
	MerchantCardId int64           `json:"merchant_card_id"` //商户卡id
	ClientOpenId   string          `json:"client_open_id"`   //openid
	Amount         decimal.Decimal `json:"amount"`           // 交易金额
	InvitationCode string          `json:"invitation_code"`  //邀请码
}

type UnifiedOrderReply struct {
	Timestamp string `json:"timestamp"` // 时间戳
	NonceStr  string `json:"nonce_str"` // 随机字符串，长度为32个字符以下
	Package   string `json:"package"`   // prepay_id 参数值
	PaySign   string `json:"pay_sign"`  // 签名
	SignType  string `json:"sign_type"` // 签名类型
}

type PayCashOutRequest struct {
	OpenId      string          `json:"open_id"`
	UserName    string          `json:"user_name"`    //收款人姓名
	Appid       string          `json:"appid"`        //
	Amount      decimal.Decimal `json:"amount"`       //金额
	AccountType string          `json:"account_type"` //账号类型  client merchant
}

type TransferDetailList struct {
	OutDetailNo    string `json:"out_detail_no"`
	TransferAmount int64  `json:"transfer_amount"`
	TransferRemark string `json:"transfer_remark"`
	Openid         string `json:"openid"`
	UserName       string `json:"user_name"`
}
